import React, { Component } from 'react';
import { View } from 'react-native';
import PropTypes from 'prop-types';

import Font from './Font';

export default class ComponentName extends Component {
  static propTypes = {
    children: PropTypes.oneOfType([
      PropTypes.string,
      PropTypes.object,
      PropTypes.array
    ]),
    paddingVertical: PropTypes.number,
    paddingHorizontal: PropTypes.number,
    borderRadius: PropTypes.number,
    badgeColor: PropTypes.string,
    textColor: PropTypes.string,
    textFontSize: PropTypes.number,
    marginTop: PropTypes.number,
    marginLeft: PropTypes.number,
  };

  static defaultProps = {
    children: '',
    paddingVertical: 2,
    paddingHorizontal: 7,
    borderRadius: 100,
    badgeColor: '#4d4d4d',
    textColor: '#ffffff',
    textFontSize: 10,
    marginTop: 0,
    marginLeft: 0
  };

  render() {
    return (
      <View
        style={{
          marginTop: this.props.marginTop,
          marginLeft: this.props.marginLeft,
          backgroundColor: this.props.badgeColor,
          paddingVertical: this.props.paddingVertical,
          paddingHorizontal: this.props.paddingHorizontal,
          borderRadius: this.props.borderRadius
        }}
      >
        { typeof this.props.children == 'string' &&
          <Font.H6 color={this.props.textColor} fontSize={this.props.textFontSize}>{ this.props.children }</Font.H6>
        }
        { typeof this.props.children != 'string' &&
          this.props.children
        }
      </View>
    );
  }
}
