import React, { Component } from 'react';
import { View, TouchableWithoutFeedback } from 'react-native';
import PropTypes from 'prop-types';

export default class Check extends Component {
  static propTypes = {
    isChecked: PropTypes.bool,
    onChange: PropTypes.func,
    name: PropTypes.string,
    color: PropTypes.string
  };

  static defaultProps = {
    isChecked: false,
    onChange: () => {},
    name: '',
    color: '#000000'
  };

  onPressCheck = () => {
    this.props.onChange(!this.props.isChecked, this.props.name);
  };

  render() {
    return (
      <TouchableWithoutFeedback onPress={this.onPressCheck}>
        <View style={{ width: 50, height: 50, justifyContent: 'center', alignItems: 'center' }}>
          <View style={{ width: 20, height: 20, borderWidth: 1, borderColor: this.props.color, borderRadius: 10, backgroundColor: this.props.isChecked ? this.props.color : '#ffffff' }} />
        </View>
      </TouchableWithoutFeedback>
    );
  }
}
