import Meteor from 'react-native-meteor';

export default class Roles {
  static userIsInRole = (userId, roles, _group) => {
    const user = Meteor.collection('users').findOne({
      _id: userId
    });

    if (!user) {
      return false;
    }

    if (!user.roles) {
      return false;
    }

    let userIsInRole = false;

    if (!Array.isArray(user.roles)) {
      const group = _group || Roles.GLOBAL_GROUP;

      if (user.roles[Roles.GLOBAL_GROUP]) {
        if (typeof roles == 'string') {
          const index = user.roles[Roles.GLOBAL_GROUP].findIndex((role) => {
            return role == roles;
          });

          if (index != -1) {
            userIsInRole = true;
          }
        }
        else {
          roles.forEach((_role) => {
            if (userIsInRole) {
              return;
            }

            const index = user.roles[Roles.GLOBAL_GROUP].findIndex((role) => {
              return role == _role;
            });

            if (index != -1) {
              userIsInRole = true;
            }
          });
        }
      }

      if (!userIsInRole && typeof roles == 'string') {
        const index = user.roles[group].findIndex((role) => {
          return role == roles;
        });

        if (index != -1) {
          userIsInRole = true;
        }
      }
      else if (!userIsInRole && typeof roles != 'string') {
        roles.forEach((_role) => {
          if (userIsInRole) {
            return;
          }

          const index = user.roles[group].findIndex((role) => {
            return role == _role;
          });

          if (index != -1) {
            userIsInRole = true;
          }
        });
      }
    }
    else {
      if (_group) {
        return false;
      }

      if (typeof roles == 'string') {
        const index = user.roles.findIndex((role) => {
          return role == roles;
        });

        if (index != -1) {
          userIsInRole = true;
        }
      }
      else {
        roles.forEach((_role) => {
          if (userIsInRole) {
            return;
          }

          const index = user.roles.findIndex((role) => {
            return role == _role;
          });

          if (index != -1) {
            userIsInRole = true;
          }
        });
      }
    }

    return userIsInRole;
  };

  static getUsersInRole = (roles, group, option) => {
    if (typeof roles == 'string') {
      if (!group) {
        return Meteor.collection('users').find({
          roles: roles
        });
      }
      else {
        const selector = {
          $or: null
        };

        selector['$or'][Roles.GLOBAL_GROUP] = roles;

        selector['$or'][`roles.${group}`] = roles;

        return Meteor.collection('users').find(selector, option);
      }
    }
    else {
      if (!group) {
        return Meteor.collection('users').find({
          roles: {
            $in: roles
          }
        });
      }
      else {
        const selector = {
          $or: null
        };

        selector['$or'][Roles.GLOBAL_GROUP].$in = roles;

        selector['$or'][`roles.${group}`].$in = roles;

        return Meteor.collection('users').find(selector, option);
      }
    }
  };

  static GLOBAL_GROUP = '__global_roles__';
}
